﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="INetworkService.cs" company="XamlNinja">
//   2011 Richard Griffin and Ollie Riches
// </copyright>
// <summary>
//   Interface defining how to get the status of the network connection.
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace dIRca.Extras
{
    using System;

    /// <summary>
    /// Interface defining how to get the status of the network connection.
    /// </summary>
    public interface INetworkService
    {
        /// <summary>
        /// Returns the status of the network connection as an observable network type.
        /// </summary>
        /// <returns>
        /// Return the status of the network connection.
        /// </returns>
        IObservable<bool> Status();
    }
}